/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.se.eip;

import java.net.URI;
import java.util.List;
import java.util.logging.Logger;

import javax.jbi.messaging.MessagingException;
import javax.jbi.servicedesc.ServiceEndpoint;

import org.ow2.petals.component.framework.exception.PEtALSCDKException;
import org.ow2.petals.component.framework.util.Exchange;
import org.ow2.petals.component.framework.util.Extensions;
import org.ow2.petals.jbi.descriptor.Consumes;
/**
 *
 * @author alouis
 *
 */
public interface ExchangeContext {

	public Logger getLogger();

	public List<Consumes> getSUConsumes(ServiceEndpoint endpoint);

	public boolean sendSync(final Exchange exchange) throws MessagingException;

	public void sendAsync(final Exchange exchange) throws MessagingException;

	public Exchange accept(Exchange exchange) throws InterruptedException, PEtALSCDKException;

	public void send(final Exchange exchange) throws MessagingException;

	public Exchange createConsumeExchange(Consumes consumes, URI mep)throws MessagingException ;

	public Extensions getExtensions();
}
